EmptyField< Data_T > Class Template Reference
Fields

This subclass of Field does not store any data. More...

`#include <EmptyField.h>`

Inheritance diagram for EmptyField< Data_T >:

## Public Types

typedef EmptyField< Data_T > | class_type
typedef boost::intrusive_ptr< EmptyField > | Ptr
typedef std::vector< Ptr > | Vec
Public Types inherited from ResizableField< Data_T >
typedef ResizableField< Data_T > | class_type
typedef boost::intrusive_ptr< ResizableField > | Ptr
Public Types inherited from WritableField< Data_T >
typedef WritableField< Data_T > | class_type
typedef boost::intrusive_ptr< WritableField > | Ptr
Public Types inherited from Field< Data_T >
typedef Field< Data_T > | class_type
typedef boost::intrusive_ptr< Field > | Ptr
typedef Data_T | value_type
| Allows us to reference the template class.
typedef std::vector< Ptr > | Vec
| This is a convenience typedef for the list that Field3DInputFile::readScalarLayers() and Field3DInputFile::readVectorLayers() will return its data in.
Public Types inherited from FieldRes
typedef FieldRes | class_type
typedef boost::intrusive_ptr< FieldRes > | Ptr
typedef std::vector< Ptr > | Vec
Public Types inherited from FieldBase
typedef FieldBase | class_type
typedef boost::intrusive_ptr< FieldBase > | Ptr
Public Types inherited from RefBase
typedef boost::intrusive_ptr< RefBase > | Ptr
typedef boost::weak_ptr< RefBase > | WeakPtr

## Public Member Functions

Constructors & destructor
| EmptyField ()
| Constructs an empty buffer.
virtual void | clear (const Data_T &value)
| Clears all the voxels in the storage.
const Data_T & | constantvalue () const
| Returns the constant value.
void | setConstantvalue (const Data_T &val)
| Sets the constant value.
From Field
virtual Data_T | value (int i, int j, int k) const
| Read access to a voxel. The coordinates are in integer voxel space .
virtual long long int | memSize () const
| Returns the memory usage (in bytes).
From WritableField
virtual Data_T & | lvalue (int i, int j, int k)
| Write access to a voxel. The coordinates are global coordinates.
From FieldBase
virtual FIELD3D_CLASSNAME_CLASSTYPE_IMPLEMENTATION FieldBase::Ptr | clone () const
| Returns a pointer to a copy of the field, pure virtual so ensure derived classes properly implement it.
Public Member Functions inherited from ResizableField< Data_T >
void | copyFrom (typename Field< Data_T >::Ptr other)
| Copies the data from another Field, also resizes.
template<class Data_T2>
void | copyFrom (typename Field< Data_T2 >::Ptr other)
| Copies the data from another Field of another template class, also resizes.
void | matchDefinition (FieldRes::Ptr fieldToMatch)
| Sets up this field so that resolution and mapping matches the other.
void | setSize (const Box3i &extents)
| Resizes the object.
void | setSize (const Box3i &extents, const Box3i &dataWindow)
| Resizes the object.
void | setSize (const V3i &size)
| Resizes the object.
void | setSize (const V3i &size, int padding)
| Resizes the object with padding.
Public Member Functions inherited from WritableField< Data_T >
iterator | begin ()
| Iterator to first element.
iterator | begin (const Box3i &subset)
| Iterator to first element of specific subset.
iterator | end ()
| Iterator pointing one element past the last valid one.
iterator | end (const Box3i &subset)
| Iterator pointing one element past the last valid one (for a subset).
Public Member Functions inherited from Field< Data_T >
const_iterator | cbegin () const
| Const iterator to first element. "cbegin" matches the tr1 c++ standard.
const_iterator | cbegin (const Box3i &subset) const
| Const iterator to first element of specific subset.
const_iterator | cend () const
| Const iterator pointing one element past the last valid one.
const_iterator | cend (const Box3i &subset) const
| Const iterator pointing one element past the last valid one (for a subset).
virtual std::string | dataTypeString () const
virtual | ~Field ()
| Dtor.
Public Member Functions inherited from FieldRes
V3i const | dataResolution () const
const Box3i & | dataWindow () const
| Returns the data window. Any coordinate inside this window is safe to pass to value() in the Field subclass.
const Box3i & | extents () const
| Returns the extents of the data. This signifies the relevant area that the data exists over. However, the data window (below) may be smaller than the extents, in which case it is only safe to call value() for those coordinate inside the data window.
| FieldRes ()
| This constructor ensures that we have a valid mapping at all times.
| FieldRes (const FieldRes &src)
| Base class copy constructor.
bool | isInBounds (int i, int j, int k) const
| Returns true is the indicies are in bounds of the data window.
FieldMapping::Ptr | mapping ()
| Returns a pointer to the mapping.
const FieldMapping::Ptr | mapping () const
| Returns a pointer to the mapping.
virtual void | mappingChanged ()
| Tells the subclass that the mapping changed.
void | setMapping (FieldMapping::Ptr mapping)
| Sets the field's mapping.
virtual size_t | voxelCount () const
| Counts the number of voxels. For most fields, this is just the volume of the data window, but sparse data structures can override this to return a better value.
Public Member Functions inherited from FieldBase
| FieldBase ()
| Constructor.
| FieldBase (const FieldBase &)
| Copy Constructor.
virtual | ~FieldBase ()
| Destructor.
virtual std::string | className () const =0
| Returns the class name of the object. Used by the class pool and when writing the data to disk.
virtual std::string | classType () const =0
| Returns the full class type string.
FieldMetadata & | metadata ()
| accessor to the m_metadata class
const FieldMetadata & | metadata () const
| Read only access to the m_metadata class.
void | copyMetadata (const FieldBase &field)
| Copies the metadata from a second field.
Public Member Functions inherited from RefBase
void | ref () const
| Used by boost::intrusive_pointer.
size_t | refcnt ()
| Used by boost::intrusive_pointer.
void | unref () const
| Used by boost::intrusive_pointer.
WeakPtr | weakPtr () const
| RefBase ()
| RefBase (const RefBase &)
| Copy constructor.
RefBase & | operator= (const RefBase &)
| Assignment operator.
virtual | ~RefBase ()
| Destructor.
virtual bool | checkRTTI (const char *typenameStr)=0
| This function is only implemented by concrete classes and triggers the actual RTTI check through matchRTTI();.
bool | matchRTTI (const char *typenameStr)
| Performs a check to see if the given typename string matches this class' This needs to be implemented in -all- subclasses, even abstract ones.
Public Member Functions inherited from MetadataCallback
virtual void | metadataHasChanged (const std::string &)
| Alerts the callback holder that the metadata has changed.

## Static Public Member Functions

static DEFINE_FIELD_RTTI_CONCRETE_CLASS const char * | staticClassName ()
static const char * | staticClassType ()
Static Public Member Functions inherited from ResizableField< Data_T >
static const char * | staticClassName ()
static const char * | staticClassType ()
Static Public Member Functions inherited from WritableField< Data_T >
static const char * | staticClassName ()
static const char * | staticClassType ()
Static Public Member Functions inherited from Field< Data_T >
static const char * | staticClassName ()
static const char * | staticClassType ()
Static Public Member Functions inherited from FieldRes
static const char * | staticClassName ()
static const char * | staticClassType ()
Static Public Member Functions inherited from FieldBase
static const char * | staticClassName ()
static const char * | staticClassType ()
static const char * | staticClassType ()

## Protected Attributes

Data_T | m_constantData
| Field constant value.
Data_T | m_default
| Field default value.
Data_T | m_ignoredData
| Dummy variable for assignment.
Protected Attributes inherited from FieldRes
Box3i | m_dataWindow
| Defines the area where data is allocated. This should be treated as a closed (i.e. inclusive) interval.
Box3i | m_extents
| Defines the extents of the the storage. This may be larger or smaller than the data window, and in the case where it is larger, care must be taken not to access voxels outside the data window. This should be treated as a closed (i.e. inclusive) interval.
FieldMapping::Ptr | m_mapping
| Pointer to the field's mapping.

## Private Types

typedef ResizableField< Data_T > | base

## Additional Inherited Members

Public Attributes inherited from ResizableField< Data_T >
| DEFINE_FIELD_RTTI_ABSTRACT_CLASS
Public Attributes inherited from WritableField< Data_T >
| DEFINE_FIELD_RTTI_ABSTRACT_CLASS
Public Attributes inherited from Field< Data_T >
| DEFINE_FIELD_RTTI_ABSTRACT_CLASS
Public Attributes inherited from FieldRes
| DEFINE_FIELD_RTTI_ABSTRACT_CLASS
Public Attributes inherited from FieldBase
std::string | attribute
| Optional name of the attribute the field represents.
std::string | name
| Optional name of the field.
Protected Types inherited from ResizableField< Data_T >
typedef WritableField< Data_T > | base
Protected Types inherited from FieldRes
typedef MatrixFieldMapping | default_mapping
Protected Member Functions inherited from ResizableField< Data_T >
virtual void | sizeChanged ()
| Subclasses should re-implement this if they need to perform memory allocations, etc. every time the size of the storage changes.
Static Protected Attributes inherited from ResizableField< Data_T >
static TemplatedFieldType< ResizableField< Data_T > > | ms_classType

## Detailed Description

template<class Data_T>
class EmptyField< Data_T >

This subclass of Field does not store any data.

Its primary purpose is to be used as a proxy field. It can carry the same resolution, metadata and mapping as a regular field.

Usage is similar to a DenseField, except that it does not contain any data. It stores a default value that may be set and queried, so it can be treated as a constant field.

Definition at line 86 of file EmptyField.h.

## Member Typedef Documentation

## Ptr

template<class Data_T>

typedef boost::intrusive_ptr<EmptyField> EmptyField< Data_T >::Ptr

Definition at line 93 of file EmptyField.h.

## Vec

template<class Data_T>

typedef std::vector<Ptr> EmptyField< Data_T >::Vec

Definition at line 94 of file EmptyField.h.

## class_type

template<class Data_T>

typedef EmptyField<Data_T> EmptyField< Data_T >::class_type

Definition at line 126 of file EmptyField.h.

## base

template<class Data_T>

typedef ResizableField<Data_T> EmptyField< Data_T >::base

private

Definition at line 173 of file EmptyField.h.

## Constructor & Destructor Documentation

## EmptyField()

template<class Data_T>

EmptyField< Data_T >::EmptyField | ( |  | ) |

Constructs an empty buffer.

Definition at line 182 of file EmptyField.h.

: base()
{
// Empty
}
EmptyField::base
ResizableField< Data_T > base
Definition EmptyField.h:173

Referenced by EmptyField< float >::clone().

## Member Function Documentation

## clear()

template<class Data_T>

void EmptyField< Data_T >::clear | ( | const Data_T & | value | ) |

virtual

Clears all the voxels in the storage.

Reimplemented from WritableField< Data_T >.

Definition at line 191 of file EmptyField.h.

{
m_constantData = m_default = value;
}
EmptyField::value
virtual Data_T value(int i, int j, int k) const
Read access to a voxel. The coordinates are in integer voxel space .
Definition EmptyField.h:199
EmptyField::m_constantData
Data_T m_constantData
Field constant value.
Definition EmptyField.h:167
EmptyField::m_default
Data_T m_default
Field default value.
Definition EmptyField.h:163

References m_constantData, m_default, and value().

## constantvalue()

template<class Data_T>

const Data_T & EmptyField< Data_T >::constantvalue | ( |  | ) | const

inline

Returns the constant value.

Definition at line 256 of file EmptyField.h.

{
return m_constantData;
}

References m_constantData.

## setConstantvalue()

template<class Data_T>

void EmptyField< Data_T >::setConstantvalue | ( | const Data_T & | val | ) |

inline

Sets the constant value.

Definition at line 248 of file EmptyField.h.

{
m_constantData = val;
}
EmptyField
This subclass of Field does not store any data.
Definition EmptyField.h:88

References m_constantData.

## value()

template<class Data_T>

Data_T EmptyField< Data_T >::value | ( | int | i,
|  | int | j,
|  | int | k ) const

virtual

Read access to a voxel. The coordinates are in integer voxel space .

Note
  Before the internal storage is accessed, the subclass must compute the data window coordinates by looking at Field::m_dataWindow.
  Virtual functions are known not to play nice with threading. Therefor, concrete classes can implement (by convention) fastValue() as a non-virtual function.

Implements Field< Data_T >.

Definition at line 199 of file EmptyField.h.

{
assert (i >= base::m_dataWindow.min.x);
assert (i <= base::m_dataWindow.max.x);
assert (j >= base::m_dataWindow.min.y);
assert (j <= base::m_dataWindow.max.y);
assert (k >= base::m_dataWindow.min.z);
assert (k <= base::m_dataWindow.max.z);
UNUSED(i);
UNUSED(j);
UNUSED(k);
// Access data
return m_default;
}
UNUSED
#define UNUSED(p)
Definition EmptyField.h:65
FieldRes::m_dataWindow
Box3i m_dataWindow
Defines the area where data is allocated. This should be treated as a closed (i.e....
Definition Field.h:310

References FieldRes::m_dataWindow, m_default, and UNUSED.

Referenced by clear().

## memSize()

template<class Data_T>

long long int EmptyField< Data_T >::memSize | ( |  | ) | const

virtual

Returns the memory usage (in bytes).

Note
  This needs to be re-implemented for any subclass that adds data members. Those classes should also call their superclass and add the combined memory use.

Reimplemented from FieldRes.

Definition at line 219 of file EmptyField.h.

{
long long int superClassMemSize = base::memSize();
return sizeof(*this) + superClassMemSize;
}
FieldRes::memSize
virtual long long int memSize() const
Returns the memory usage (in bytes).
Definition Field.h:279

References FieldRes::memSize().

## staticClassName()

template<class Data_T>

DEFINE_FIELD_RTTI_CONCRETE_CLASS const char * EmptyField< Data_T >::staticClassName | ( |  | ) |

inline static

Definition at line 129 of file EmptyField.h.

{
return staticClassType();
}
EmptyField::staticClassType
static const char * staticClassType()
Definition EmptyField.h:134

## staticClassType()

template<class Data_T>

const char * EmptyField< Data_T >::staticClassType | ( |  | ) |

inline static

Definition at line 134 of file EmptyField.h.

{
return "EmptyField";
}

Referenced by EmptyField< float >::staticClassName().

## lvalue()

template<class Data_T>

Data_T & EmptyField< Data_T >::lvalue | ( | int | i,
|  | int | j,
|  | int | k )

virtual

Write access to a voxel. The coordinates are global coordinates.

Note
  Before the internal storage is accessed, the subclass must compute the crop window coordinates by looking at Field::m_dataWindow.
  This is named differently from the const value so that non-const objects still have a clear way of accessing data in a const way.
  Virtual functions are known not to play nice with threading. Therefor, concrete classes can implement (by convention) fastLValue() as a non-virtual function.

Implements WritableField< Data_T >.

Definition at line 228 of file EmptyField.h.

{
assert (i >= base::m_dataWindow.min.x);
assert (i <= base::m_dataWindow.max.x);
assert (j >= base::m_dataWindow.min.y);
assert (j <= base::m_dataWindow.max.y);
assert (k >= base::m_dataWindow.min.z);
assert (k <= base::m_dataWindow.max.z);
UNUSED(i);
UNUSED(j);
UNUSED(k);
// Access data
return m_ignoredData;
}
EmptyField::m_ignoredData
Data_T m_ignoredData
Dummy variable for assignment.
Definition EmptyField.h:165

References FieldRes::m_dataWindow, m_ignoredData, and UNUSED.

## clone()

template<class Data_T>

virtual FIELD3D_CLASSNAME_CLASSTYPE_IMPLEMENTATION FieldBase::Ptr EmptyField< Data_T >::clone | ( |  | ) | const

inline virtual

Returns a pointer to a copy of the field, pure virtual so ensure derived classes properly implement it.

Implements FieldBase.

Definition at line 153 of file EmptyField.h.

{ return Ptr(new EmptyField(*this)); }
EmptyField::Ptr
boost::intrusive_ptr< EmptyField > Ptr
Definition EmptyField.h:93
EmptyField::EmptyField
EmptyField()
Constructs an empty buffer.
Definition EmptyField.h:182

## Member Data Documentation

## m_default

template<class Data_T>

Data_T EmptyField< Data_T >::m_default

protected

Field default value.

Definition at line 163 of file EmptyField.h.

Referenced by clear(), and value().

## m_ignoredData

template<class Data_T>

Data_T EmptyField< Data_T >::m_ignoredData

protected

Dummy variable for assignment.

Definition at line 165 of file EmptyField.h.

Referenced by lvalue().

## m_constantData

template<class Data_T>

Data_T EmptyField< Data_T >::m_constantData

protected

Field constant value.

Definition at line 167 of file EmptyField.h.

Referenced by clear(), constantvalue(), and setConstantvalue().

The documentation for this class was generated from the following file:

- export/EmptyField.h